uses n2_image,n2_vector,n2_matrix,n2_mathe,pivtools2,random,n2_transforms,n2_complex;

const bsx=384;
      bsy=384;
      pdens=0.02;
      tintn=10;
      pintn=10;
      
var ma,mb,mu,mv:tmatrix;
    c:longint;

procedure pivimgsave(m:tmatrix;s:string);
var img:timage;
	i,j:longint;
begin
  img.sx:=length(m[0]);
  img.sy:=length(m);
  img.imgtype:=tru;
  img.coltype:=y;
  setlength(img.img.y,img.sy,img.sx);
  for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do img.img.y[img.sy-1-j,i]:=maxi(0,mini(255,round(255*m[j,i])));
  img.maxy:=255;
  pngdump(img,s);
end;

procedure pivuvsave(mu,mv:tmatrix;s:string);
var fo:text;
    i,j:longint;
begin
  assign(fo,s);
  rewrite(fo);
  for j:=0 to bsy-1 do for i:=0 to bsx-1 do writeln(fo,i+0.5:0:1,',',j+0.5:0:1,',',mu[j,i],',',mv[j,i]);
  close(fo)
end;

function getintu(x,y:double;u:tmatrix):double;
var s:double;
    i,j,idx,idy:longint;
begin
  if (x>=0) and (x<=bsx) and (y>=0) and (y<=bsy) then
  begin
    idx:=maxi(4,mini(bsx-4,round(x)));
    idy:=maxi(4,mini(bsy-4,round(y)));
    s:=0;
    for j:=idy-4 to idy+3 do for i:=idx-4 to idx+3 do s:=s+u[j,i]*si(pi*(x-0.5-i))*si(pi*(y-0.5-j));
    getintu:=s;
  end;
end;

procedure pivimgmake(diam,oo:double);
var i,j,parti,ii,jj,k:longint;
	ax1,ax2,ay1,ay2,aa1,aa2:tvector;
    u,v,x1,x2,y1,y2,d,z1,aa:double;
    mu1,mv1:tmatrixc;
begin
//velocities;
  mu1:=initmc(bsy,bsx);
  mv1:=initmc(bsy,bsx);
  for j:=0 to bsy-1 do for i:=0 to bsx-1 do mu1[j,i]:=setc(gaussran,0);
  for j:=0 to bsy-1 do for i:=0 to bsx-1 do mv1[j,i]:=setc(gaussran,0);
  mu1:=ft(mu1);
  mv1:=ft(mv1);
  for j:=0 to bsy-1 do for i:=0 to bsx-1 do mu1[j,i]:=mulc(mu1[j,i],abs(1-j/(bsy/2))*abs(1-i/(bsx/2)));
  for j:=0 to bsy-1 do for i:=0 to bsx-1 do mv1[j,i]:=mulc(mv1[j,i],abs(1-j/(bsy/2))*abs(1-i/(bsx/2)));
  mu1:=ift(mu1);
  mv1:=ift(mv1);
  for j:=0 to bsy-1 do for i:=0 to bsx-1 do mu[j,i]:=mu1[j,i].re;
  for j:=0 to bsy-1 do for i:=0 to bsx-1 do mv[j,i]:=mv1[j,i].re;
//particles;
  parti:=poissonran(pdens*(bsx+10)*(bsy+10)*(1+oo));
  ax1:=initv(parti);
  ay1:=initv(parti);
  aa1:=initv(parti);
  ax2:=initv(parti);
  ay2:=initv(parti);
  aa2:=initv(parti);
  for i:=0 to parti-1 do
  begin
    x1:=(bsx+10)*gleichran-5;
    y1:=(bsy+10)*gleichran-5;
	x2:=x1;
	y2:=y1;
	for j:=1 to tintn do
	begin
	  u:=getintu(x1,y1,mu);
	  v:=getintu(x1,y1,mv);
	  x1:=x1-u/2/tintn;
	  y1:=y1-v/2/tintn;
	  u:=getintu(x2,y2,mu);
	  v:=getintu(x2,y2,mv);
	  x2:=x2+u/2/tintn;
	  y2:=y2+v/2/tintn;
	end;
    ax1[i]:=x1;
    ay1[i]:=y1;
    ax2[i]:=x2;
    ay2[i]:=y2;
	z1:=gleichran*(1+oo);
	aa:=gleichran;
    aa1[i]:=aa*byte(z1<1);
    aa2[i]:=aa*byte(z1>oo);
  end;

  for j:=0 to bsy-1 do for i:=0 to bsx-1 do  
  begin
    ma[j,i]:=0;
	for k:=0 to parti-1 do 
	begin
	  d:=sqr(j+0.5-ay1[k])+sqr(i+0.5-ax1[k]);
	  if d<100 then 
	  begin
	    for jj:=0 to pintn-1 do for ii:=0 to pintn-1 do
		  ma[j,i]:=ma[j,i]+aa1[k]*getairy(sqrt(sqr(i+(ii+0.5)/pintn-ax1[k])+sqr(j+(jj+0.5)/pintn-ay1[k])),diam)/sqr(pintn);
      end;
	end;
    mb[j,i]:=0;
	for k:=0 to parti-1 do 
	begin
	  d:=sqr(j+0.5-ay2[k])+sqr(i+0.5-ax2[k]);
	  if d<100 then 
	  begin
	    for jj:=0 to pintn-1 do for ii:=0 to pintn-1 do
		  mb[j,i]:=mb[j,i]+aa2[k]*getairy(sqrt(sqr(i+(ii+0.5)/pintn-ax2[k])+sqr(j+(jj+0.5)/pintn-ay2[k])),diam)/sqr(pintn);
      end;
	end;
  end;
end;


begin
  mu:=initm(bsy,bsx);
  mv:=initm(bsy,bsx);
  ma:=initm(bsy,bsx);
  mb:=initm(bsy,bsx);
  for c:=0 to 199 do
  begin
    pivimgmake(3.0,0.25);
    pivimgsave(ma,'ts2_'+chr(ord('0')+c div 100)+chr(ord('0')+(c div 10) mod 10)+chr(ord('0')+c mod 10)+'a.png');
    pivimgsave(mb,'ts2_'+chr(ord('0')+c div 100)+chr(ord('0')+(c div 10) mod 10)+chr(ord('0')+c mod 10)+'b.png');
    pivuvsave(mu,mv,'ts2_'+chr(ord('0')+c div 100)+chr(ord('0')+(c div 10) mod 10)+chr(ord('0')+c mod 10)+'.xyuv');
  end;
end.
